safe_asterisk
来自「一个非常美妙的proxy。功能强大。基于sip的协议。如果还要的话」· 代码 · 共 86 行
TXT
86 行
#!/bin/shCLIARGS="$*" # Grab any args passed to safe_asteriskTTY=9 # TTY (if you want one) for Asterisk to run onCONSOLE=yes # Whether or not you want a console#NOTIFY=ben@alkaloid.net # Who to notify about crashesMACHINE=`hostname` # To specify which machine has crashed when getting the mailDUMPDROP=/tmpASTSBINDIR=__ASTERISK_SBIN_DIR__## Don't fork when running "safely"#ASTARGS=""if [ "$TTY" != "" ]; then if [ -c /dev/tty${TTY} ]; then TTY=tty${TTY} elif [ -c /dev/vc/${TTY} ]; then TTY=vc/${TTY} else echo "Cannot find your TTY (${TTY})" >&2 exit 1 fi ASTARGS="${ASTARGS} -vvvg" if [ "$CONSOLE" != "no" ]; then ASTARGS="${ASTARGS} -c" fifiif [ ! -w ${DUMPDROP} ]; then echo "Cannot write to ${DUMPDROP}" >&2 exit 1fi## Let Asterisk dump core#ulimit -c unlimited#launch_asterisk()#{#}run_asterisk(){ while :; do if [ "$TTY" != "" ]; then cd /tmp stty sane < /dev/${TTY} ${ASTSBINDIR}/asterisk ${CLIARGS} ${ASTARGS} >& /dev/${TTY} < /dev/${TTY} else cd /tmp ${ASTSBINDIR}/asterisk ${CLIARGS} ${ASTARGS} fi EXITSTATUS=$? echo "Asterisk ended with exit status $EXITSTATUS" if [ "$EXITSTATUS" = "0" ]; then # Properly shutdown.... echo "Asterisk shutdown normally." exit 0 elif [ $EXITSTATUS -gt 128 ]; then let EXITSIGNAL=EXITSTATUS-128 echo "Asterisk exited on signal $EXITSIGNAL." if [ "$NOTIFY" != "" ]; then echo "Asterisk on $MACHINE exited on signal $EXITSIGNAL. Might want to take a peek." | \ mail -s "Asterisk Died" $NOTIFY fi if [ -f /tmp/core ]; then mv /tmp/core ${DUMPDROP}/core.`hostname`-`date -Iseconds` & fi else if [ "${EXITSTATUS}" = "0" ]; then echo "Asterisk ended normally. Aborting." exit 0 else echo "Asterisk died with code $EXITSTATUS." if [ -f /tmp/core ]; then mv /tmp/core ${DUMPDROP}/core.`hostname`-`date -Iseconds` & fi fi fi echo "Automatically restarting Asterisk." sleep 4 done}run_asterisk &
⌨️ 快捷键说明
复制代码Ctrl + C
搜索代码Ctrl + F
全屏模式F11
增大字号Ctrl + =
减小字号Ctrl + -
显示快捷键?